https = {timeout = 5,time = 0,body = "",status = 0};

function https.request(url,method,data)
	if love.system.getOS() == "Windows" then
		love.filesystem.remove("status.txt");
		love.filesystem.remove("body.txt");
		love.filesystem.remove("https.js");
		url = url or "";
		method = method or "GET";
		data = data or "";
		data = data:gsub(" ","/SPACE/");
		data = data:gsub("&","/AND/");
		createJS();
		local dir = love.filesystem.getAppdataDirectory() .. "/LOVE/" .. love.filesystem.getIdentity() .. "/https.js";
		local str = "" .. dir:gsub("/","\\") .. " " .. url .. " " .. method .. " " .. data .. "";
		os.execute(str);
		
		https.timer = os.time();
		local ok = updateHttpsRequest(love.timer.getDelta());
		return ok,https.body,https.status;
	end
end

function createJS()
	local file = [[var xHttp;
var URL;
var method;
var FSO;
var file;
var data;
var scriptDir = WScript.ScriptFullName.substring(0,WScript.ScriptFullName.lastIndexOf(WScript.ScriptName)-1);

xHttp = new ActiveXObject("MSXML2.ServerXMLHTTP");
URL = WScript.Arguments.Item(0);

try {
	method = WScript.Arguments.Item(1);
	data = WSCript.Arguments.Item(2);
	data = data.replace("/SPACE/"," ");
	data = data.replace("/AND/","&");
} catch(err) {

}

if (!method) {
	method = "GET";
}

if (!data) {
	var d = new Date();
	data = "c=" + d.getTime();
} else {
	var d = new Date();
	data = data + "&d=" + d.getTime();
}


xHttp.open(method, URL, false);
xHttp.setOption(2, 13056);
xHttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
xHttp.setRequestHeader("Charset","utf-8");
xHttp.send(data);

FSO = new ActiveXObject("Scripting.FileSystemObject");

fileName = scriptDir + "\\body.txt";

var fsT = new ActiveXObject("ADODB.Stream");
fsT.type = 2; 
fsT.charset = "utf-8"; 
fsT.open(); 
fsT.writeText(xHttp.responseText);
fsT.saveToFile(fileName, 2);

fileName = scriptDir + "\\status.txt";
file = FSO.CreateTextFile(fileName,true);
file.Write(xHttp.status + "\n");
file.Close();
]]

love.filesystem.write("https.js",file);
end

function updateHttpsRequest(dt)
	while true do
		
		if love.filesystem.isFile("status.txt") and love.filesystem.isFile("body.txt") then
			https.status = tonumber(love.filesystem.read("status.txt"):sub(1,3));
			https.body = love.filesystem.read("body.txt");

			print("len:" .. https.body:len());
			if https.status == 200 then
				return true;
			else 
				return false;
			end
		end
		if os.time() > https.timeout + https.time then
			https.body = "";
			https.status = -1;
			return false;
		end
		love.timer.sleep();
	end
end


