require("https");
utf8 = require("utf8");

function love.load()
	URL = "https://love2d.org";
	love.filesystem.setIdentity("testHTTPS");
	font1 = love.graphics.newFont(20);
	font2 = love.graphics.newFont(13);

	doingRequest = 0;
end


function love.update(dt)
	if doingRequest == 1 then doingRequest = 2 
	elseif doingRequest == 2 then
		local ok, body, status = https.request(URL,"GET","foo=bar&bar=foo");
		doingRequest = 0;
	end
end

function love.draw()
	draw();
end

function draw()
	if doingRequest == 0 then
		love.graphics.setFont(font1);
		love.graphics.setColor(1,0,0);
		love.graphics.rectangle("fill",250,5,300,100);
		love.graphics.setColor(1,1,1);
		love.graphics.print("Click here to do an https\nrequest to " .. URL,255,35);
	else
		love.graphics.setFont(font1);
		love.graphics.setColor(1,1,1);
		love.graphics.print("Requesting...",375,10);
	end

	if https.body then
		love.graphics.setFont(font2);
		love.graphics.setColor(1,1,1);
		love.graphics.print(tostring(https.body),10,120);
	end
end

function love.mousereleased(x,y)
	if x > 250 and y > 5 and x < 550 and y < 105 then
		doingRequest = 1
	end
end



